#!/usr/local/rebol/rebol -cs

REBOL [
	author: 'chl
	date: 2004-02-18
]

; print "Content-type: text/html^/^/"

do load %url-encode.r
do %make-swf/make-swf.r

output-dir: %/home/chris/www/rswf-output/yahoo-vs-google/
output-url-prefix: http://www.langreiter.com/rswf-output/yahoo-vs-google/

google-url: http://www.google.com/search?num=100&as_q=
yahoo!-url: http://search.yahoo.com/search?n=100&p=

as-pair: func [ x y ] [
	to-pair reduce [ to-integer x to-integer y ]
]

strip-slash: func [ x ] [
	if (#"/" = last x) [
		return copy/part x ((length? x) - 1)	
	]
	x
]

dewww: func [ x ] [
	if all [
		found? find x "www."
		1 = index? find x "www."
	] [
		head replace x "www." ""
	]
	x
]

normalize: func [ x ] [
	dewww strip-slash x
]

index?-or-none: func [ x ] [ 
	either series? x [ index? x ] [ none ] 
]

search: func [ u s e x /local page urls url ] [
	page: read join u url-encode x
	urls: copy [] 
	parse page [ 
		any [ 
			thru s copy url to e
			(insert tail urls join http:// normalize url) 
		]
	]
	urls	
]

search-google: func [ x ] [
	search google-url {<font color=#008000>} " " x
]

search-yahoo!: func [ x ] [
	search yahoo!-url {<br><font color=008000>} "</font>" x
]

search-yahoo!: func [ x /local page urls url ] [
	page: read join yahoo!-url url-encode x
	urls: copy [] 
	parse page [ 
		any [ 
			thru {<font color=008000>} copy url to {</font>}
			thru "</li>"
			(insert tail urls join http:// normalize url) 
		]
	]
	urls	
]

cross-check-results: func [ gr yr /local google-in-yahoo! yahoo!-in-google ] [
	google-in-yahoo!: copy []
	yahoo!-in-google: copy []
	foreach e gr [
		append google-in-yahoo! index?-or-none find yr e
	]
	foreach e yr [
		append yahoo!-in-google index?-or-none find gr e
	]
	reduce [ google-in-yahoo! yahoo!-in-google ]
]

cross-check: func [ x ] [
	cross-check-results search-google x search-yahoo! x
]

generate-swf: func [ x ] [
	cross-check-result: cross-check x ; @@ semi-evil
	make-swf %yahoo-vs-google.rswf
]

if not none? system/options/args [
	halt
]

params: decode-cgi any [ system/options/cgi/query-string "" ]
q: any [ select params to-set-word 'q "synerge" ]

file: join url-encode q ".swf"
if not exists? qualified-file: join output-dir file [
	write/binary qualified-file generate-swf q
	save join qualified-file ".txt" cross-check-result
]

print rejoin [ "Location: " output-url-prefix url-encode file ]  
print join "Expires: 0" newline

